## deal.ii 9.3.0

=== source/sundials/CMakeLists.txt ===
## ---------------------------------------------------------------------
##
## Copyright (C) 2012 - 2021 by the deal.II authors
##
## This file is part of the deal.II library.
##
## The deal.II library is free software; you can use it, redistribute
## it, and/or modify it under the terms of the GNU Lesser General
## Public License as published by the Free Software Foundation; either
## version 2.1 of the License, or (at your option) any later version.
## The full text of the license can be found in the file LICENSE.md at
## the top level directory of deal.II.
##
## ---------------------------------------------------------------------

INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

SET(_src
  arkode.cc
  ida.cc
  kinsol.cc
  n_vector.cc
  sunlinsol_wrapper.cc
  )

SET(_inst
  n_vector.inst.in
  )

FILE(GLOB _header
  ${CMAKE_SOURCE_DIR}/include/deal.II/sundials/*.h
  )

DEAL_II_ADD_LIBRARY(obj_sundials OBJECT ${_src} ${_header} ${_inst})
EXPAND_INSTANTIATIONS(obj_sundials "${_inst}")

=== debian/changelog ===
deal.ii (9.3.0-1~exp1build1) impish; urgency=medium

  * No-change rebuild against glibc 2.34

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 17 Aug 2021 17:35:49 +0000

deal.ii (9.3.0-1~exp1) experimental; urgency=medium

  * New upstream release
  * Reenable sundials
  * Update minimal version requirements for external dependencies

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Sun, 06 Jun 2021 19:44:37 +0000

deal.ii (9.2.0-3) unstable; urgency=medium

  * Add autopkgtest checking Trilinos compatibility
  * Bump Standards-Version to 4.5.1
  * update debhelper compatiblity level to 13, add debian/not-installed
  * fix multiarch hinter warning

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Thu, 03 Dec 2020 07:26:03 +0000

deal.ii (9.2.0-2) unstable; urgency=medium

  * Remove sundials dependency: Newer sundials versions are currently not
    supported by upstream

 -- Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>  Mon, 31 Aug 2020 06:57:08 +0000

=== debian/control ===
Source: deal.ii
Section: libs
Priority: optional
Standards-Version: 4.5.1
Rules-Requires-Root: no
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Maier <tamiko+DEBIAN@kyomu.43-1.org>,
           Graham Inggs <ginggs@debian.org>
Vcs-Browser: https://salsa.debian.org/science-team/deal.ii
Vcs-Git: https://salsa.debian.org/science-team/deal.ii.git
Homepage: http://www.dealii.org/
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               gmsh,
               graphviz,
               libadolc-dev (>= 2.6.4),
               libarpack2-dev,
               libassimp-dev,
               libboost-iostreams-dev,
               libboost-math-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgmsh-dev,
               libgsl-dev,
               libhdf5-dev,
               libhdf5-mpi-dev,
               liblapack-dev,
               libmetis-dev,
               libmuparser-dev,
               libocct-data-exchange-dev,
               libocct-foundation-dev,
               libocct-ocaf-dev,
               libocct-visualization-dev,
               libp4est-dev (>= 2.0),
               libscalapack-mpi-dev,
               libsuitesparse-dev,
               libsundials-dev (>= 5.7.0),
               libtbb-dev,
               mpi-default-dev,
               petsc-dev,
               python3-minimal:native,
               slepc-dev,
               trilinos-all-dev,
               zlib1g-dev

Package: libdeal.ii-dev
Section: libdevel
Architecture: any
Depends: libadolc-dev (>= 2.6.4),
         libarpack2-dev,
         libassimp-dev,
         libboost-iostreams-dev,
         libboost-math-dev,
         libboost-serialization-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libdeal.ii-9.3.0 (= ${binary:Version}),
         libgmsh-dev,
         libgsl-dev,
         libhdf5-dev,
         libhdf5-mpi-dev,
         liblapack-dev,
         libmetis-dev,
         libmuparser-dev,
         libocct-data-exchange-dev,
         libocct-foundation-dev,
         libocct-ocaf-dev,
         libocct-visualization-dev,
         libp4est-dev (>= 2.0),
         libscalapack-mpi-dev,
         libsuitesparse-dev,
         libsundials-dev (>= 5.7.0),
         libtbb-dev,
         mpi-default-dev,
         petsc-dev,
         slepc-dev,
         trilinos-all-dev,
         zlib1g-dev,
         ${misc:Depends}
Recommends: cmake, g++, numdiff
Description: Differential Equations Analysis Library - development files
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the development files.

Package: libdeal.ii-9.3.0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gmsh
Pre-Depends: ${misc:Pre-Depends}
Description: Finite Element Differential Equations Analysis Library
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the shared libraries.

Package: libdeal.ii-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: fonts-mathjax-extras, libjs-mathjax, ${misc:Depends}
Description: Differential Equations Analysis Library - html doc. and examples
 deal.II is a C++ program library targeted at the computational solution of
 partial differential equations using adaptive finite elements. It uses
 state-of-the-art programming techniques to offer you a modern interface to the
 complex data structures and algorithms required.
 .
 This package contains the documentation and examples.

=== debian/rules ===
#! /usr/bin/make -f

export OMPI_MCA_plm_rsh_agent=/bin/false
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --max-parallel=2

# The following (optional) dependencies are missing because they are not
# packaged in debian:
#   adolc (package in debian too old)
#   ginkgo (https://ginkgo-project.github.io/)
#   symengine (https://github.com/sympy/symengine)
override_dh_auto_configure:
	dh_auto_configure -- \
	-DDEAL_II_CXX_FLAGS="-Wno-nonnull-compare -Wno-address" \
	-DCMAKE_PREFIX_PATH="/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi;/usr/include/hdf5/openmpi" \
	-DCMAKE_BUILD_TYPE=DebugRelease \
	-DDEAL_II_ALLOW_AUTODETECTION=OFF \
	-DDEAL_II_ALLOW_BUNDLED=OFF \
	-DDEAL_II_ALLOW_PLATFORM_INTROSPECTION=OFF \
	-DDEAL_II_COMPILE_EXAMPLES=OFF \
	-DDEAL_II_COMPONENT_DOCUMENTATION=ON \
	-DDEAL_II_DOXYGEN_USE_MATHJAX=ON \
	-DDEAL_II_DOXYGEN_USE_ONLINE_MATHJAX=OFF \
	-DMATHJAX_PATH="/usr/share/javascript/mathjax" \
	-DDEAL_II_COMPONENT_EXAMPLES=ON \
	-DDEAL_II_HAVE_FP_EXCEPTIONS=FALSE \
	-DDEAL_II_WITH_ADOLC=ON \
	-DDEAL_II_WITH_ARPACK=ON \
	-DDEAL_II_WITH_ASSIMP=ON \
	-DDEAL_II_WITH_BOOST=ON \
	-DDEAL_II_WITH_COMPLEX_VALUES=ON \
	-DDEAL_II_WITH_GMSH=ON \
	-DDEAL_II_WITH_GSL=ON \
	-DDEAL_II_WITH_HDF5=ON \
	-DDEAL_II_WITH_KOKKOS=ON \
	-DDEAL_II_WITH_LAPACK=ON \
	-DDEAL_II_WITH_METIS=ON \
	-DDEAL_II_WITH_MPI=ON \
	-DDEAL_II_WITH_MUPARSER=ON \
	-DDEAL_II_WITH_OPENCASCADE=ON \
	-DDEAL_II_WITH_P4EST=ON \
	-DDEAL_II_WITH_PETSC=ON \
	-DDEAL_II_WITH_SCALAPACK=ON \
	-DDEAL_II_WITH_SUNDIALS=ON \
	-DDEAL_II_WITH_SLEPC=ON \
	-DDEAL_II_WITH_TBB=ON \
	-DDEAL_II_WITH_TRILINOS=ON \
	-DDEAL_II_WITH_UMFPACK=ON \
	-DDEAL_II_WITH_ZLIB=ON \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF \
	-DDEAL_II_BASE_NAME="deal.ii" \
	-DDEAL_II_DOCHTML_RELDIR=share/doc/libdeal.ii-doc/html \
	-DDEAL_II_DOCREADME_RELDIR=share/doc/libdeal.ii-doc \
	-DDEAL_II_EXAMPLES_RELDIR=share/doc/libdeal.ii-doc/examples \
	-DDEAL_II_LIBRARY_RELDIR=lib/$(DEB_HOST_MULTIARCH) \
	-DDEAL_II_PROJECT_CONFIG_RELDIR=share/cmake/deal.II \
	-DDEAL_II_SHARE_RELDIR=share/deal.ii/

override_dh_auto_test:
	dh_auto_test --max-parallel=1

TMP_DOC := debian/tmp/usr/share/doc/libdeal.ii-doc
override_dh_auto_install:
	dh_auto_install
	# Copy over all external html resources:
	cp -r doc/doxygen/deal.II/images $(TMP_DOC)/html/doxygen/deal.II/
	# Replace links external deal.II html resources by local links:
	sed -i 's#"https\?://www.dealii.org/images/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html \
		$(TMP_DOC)/html/doxygen/deal.II/namespaceGridGenerator_1_1Airfoil.html
	# Replace zenodo links:
	sed -i -e 's#"https://zenodo.org/badge/DOI/10.5281/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/step_*.html \
		$(TMP_DOC)/html/doxygen/deal.II/class*.html
	sed -i -e 's#"https://upload.wikimedia.org/wikipedia/commons/#"images/#g' \
		$(TMP_DOC)/html/doxygen/deal.II/group_*.html
	# Remove external links to the W3C validator icon:
	find $(TMP_DOC)/html \
		-type f -name '*.html' -exec sed -i 's#\(<img.*w3.org.*\)</a>#</a>#' {} \;
	# Remove superfluous license file
	rm $(TMP_DOC)/LICENSE.md

override_dh_compress:
	# Do not compress example source code, and icons:
	dh_compress -X.cc -X.ico

override_dh_dwz:
	# Double up the limit of debug information entries:
	dh_dwz -- -L 100000000

VERSION := 9.3.0
get-orig-source:
	wget --no-clobber -O deal.ii-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION).tar.gz
	wget --no-clobber -O deal.ii-doc-$(VERSION).tar.gz https://github.com/dealii/dealii/releases/download/v$(VERSION)/dealii-$(VERSION)-offline_documentation.tar.gz
	mkdir deal.ii-$(VERSION)
	tar --strip-components=1 -C deal.ii-$(VERSION) -xzf deal.ii-$(VERSION).tar.gz
	mkdir -p deal.ii-$(VERSION)/doc/doxygen/deal.II
	tar -C deal.ii-$(VERSION) -xzf deal.ii-doc-$(VERSION).tar.gz doc/doxygen/deal.II/images
	set -e; cd deal.ii-$(VERSION); \
		rm -rf bundled
	tar -cJf deal.ii_$(VERSION).orig.tar.xz deal.ii-$(VERSION)
	rm -rf deal.ii-$(VERSION)
